//+------------------------------------------------------------------+
//|                                                   Silent_RSI.mq4 |
//|          Copyright 2015, Silentspec Megamozg Intergalactic Corp. |
//+------------------------------------------------------------------+
#property copyright "Copyright 2015, Silentspec Megamozg Intergalactic Corp."
#property version   "1.06"

#include <MyWinUser32.mqh> //  

// ChangeLog
/*
v1.01
-    
-   
v1.02
-     -   
-     2
-       
-     
-    
-    e-mail
-    push-
-      
-   " " (4)
v1.03
-   (    , e-mail  push-),   
-   5 -      RSI    
-   6 -   50  RSI
-         50 (RSI, MA1, MA2)
v1.04
-       RSI   
-      
-  -
-    
-  
v1.05
-  
v1.06
-    3
-    5
*/

#property indicator_separate_window
#property indicator_minimum 0
#property indicator_maximum 100
#property indicator_buffers 14

extern string              Set01=" RSI";
input ENUM_TIMEFRAMES      RSI_Timeframe=0;
extern int                 RSI_Period = 14;
input ENUM_APPLIED_PRICE   RSI_Applied_Price = 0;
input ENUM_LINE_STYLE      RSI_Style=STYLE_SOLID;
enum RSIW
{
RSIW1=1,                    //1
RSIW2=2,                    //2
RSIW3=3,                    //3
RSIW4=4,                    //4
RSIW5=5,                    //5
};
input RSIW                 RSI_Width = 2;
int                        RSI_overBought_Width=RSI_Width+2;
int                        RSI_overSold_Width=RSI_Width+2;
extern color               RSI_Color = Aqua;
extern color               RSI_overBought_Color = Red;
extern color               RSI_overSold_Color = Lime;
extern string              Set07="  RSI";
extern double              MaxoverBought = 90;
extern double              overBought = 80;
extern double              overSold = 20;
extern double              MaxoverSold = 10;
extern bool                Show_RSI_Levels = true;
extern color               RSI_Levels_Color = Yellow;
input ENUM_LINE_STYLE      RSI_Levels_Style=STYLE_DOT;
enum RSILW
{
RSILW1=1,                    //1
RSILW2=2,                    //2
RSILW3=3,                    //3
RSILW4=4,                    //4
RSILW5=5,                    //5
};
input RSILW                RSI_Levels_Width = 1;
extern string              Set02=" MA 1";
extern bool                Show_MA1 = true;
extern int                 MA1_Period = 21;
input ENUM_APPLIED_PRICE   MA1_Applied_Price = 0;
input ENUM_MA_METHOD       MA1_Method = 1;
input ENUM_LINE_STYLE      MA1_Style=STYLE_SOLID;
enum MA1W
{
MA1W1=1,                    //1
MA1W2=2,                    //2
MA1W3=3,                    //3
MA1W4=4,                    //4
MA1W5=5,                    //5
};
input MA1W                 MA1_Width = 1;
extern color               MA1_Color = Red;
extern string              Set03=" MA 2";
extern bool                Show_MA2 = true;
extern int                 MA2_Period = 48;
input ENUM_APPLIED_PRICE   MA2_Applied_Price = 0;
input ENUM_MA_METHOD       MA2_Method = 1;
input ENUM_LINE_STYLE      MA2_Style=STYLE_SOLID;
enum MA2W
{
MA2W1=1,                    //1
MA2W2=2,                    //2
MA2W3=3,                    //3
MA2W4=4,                    //4
MA2W5=5,                    //5
};
input MA2W                 MA2_Width = 1;
extern color               MA2_Color = DeepSkyBlue;
extern string              Set04=" TMA";
extern bool                Show_TMA = true;
extern int                 HalfLength = 12;
extern int                 DevPeriod  = 100;
extern double              Deviations = 1.5;
input ENUM_LINE_STYLE      TMA_Style=STYLE_DASH;
enum TMAW
{
TMAW1=1,                    //1
TMAW2=2,                    //2
TMAW3=3,                    //3
TMAW4=4,                    //4
TMAW5=5,                    //5
};
input TMAW                 TMA_Width = 1;
extern color               TMACenter_Color = White;
extern color               TMAHigh_Color = Gold;
extern color               TMALow_Color = Turquoise;
extern string              Set05 = " BollingerBands";
extern bool                Show_BB = false;
extern int                 bb_period = 36;
extern double              bb_dev = 2.0;
input ENUM_MA_METHOD       BB_Method = 0;
input ENUM_LINE_STYLE      bb_Style = STYLE_DASH;
enum BBW
{
BBW1=1,                    //1
BBW2=2,                    //2
BBW3=3,                    //3
BBW4=4,                    //4
BBW5=5,                    //5
};
input BBW                  bb_Width = 1;
extern color               bb_Center_Color = White;
extern color               bb_High_Color = Gold;
extern color               bb_Low_Color = Turquoise;
extern string              Set08=" ";
extern bool                showZoneArrows = true;
extern bool                showMaxZoneArrows = true;
extern bool                showMACrossArrows = true;
extern bool                showDiv = true;
extern bool                showChannelArrow = true;
extern bool                show50cross = true;
enum CROSS
{
CROSS1=1,                    //RSI
CROSS2=2,                    //MA
};
input CROSS                cross50 = 2;
extern int                 RSI_Trend_Period = 100;
input ENUM_APPLIED_PRICE   RSI_Trend_Applied_Price = 0;
extern int                 MA_Trend_Period = 200;
input ENUM_APPLIED_PRICE   MA_Trend_Applied_Price = 0;
input ENUM_MA_METHOD       MA_Trend_Method = 1;
extern bool                UseTrendFiltration = false;
extern int                 ArrowDelta = 50;
extern color               ZoneArrows_Up_Color = Lime;
extern color               ZoneArrows_Dn_Color = Red;
extern color               MaxZoneArrows_Up_Color = DeepSkyBlue;
extern color               MaxZoneArrows_Dn_Color = Magenta;
extern color               MACrossArrows_Up_Color = MediumSeaGreen;
extern color               MACrossArrows_Dn_Color = Tomato;
extern color               Div_Up_Color = OliveDrab;
extern color               Div_Dn_Color = DarkOrange;
extern color               Channel_Up_Color = DarkViolet;
extern color               Channel_Dn_Color = Gold;
extern color               cross50_Up_Color = LightSeaGreen;
extern color               cross50_Dn_Color = Crimson;
input ENUM_TIMEFRAMES      DataRefreshPeriod = PERIOD_H1;                       //   
extern int                 RetryAttempts =   10;
extern int                 MaxBars =   1000;
extern bool                Play_Alert = true;
extern bool                Play_Sound = true;
extern bool                UseSnapShot = false;
extern bool                UseSendMail = false;
extern bool                UseSendPush = false;
extern bool                UseReconnect = false;
extern bool                UsePanel =                    true;
extern color               TopField =                    PowderBlue;
extern color               DataField =                   SlateGray;
extern color               ExpNameCol =                  DodgerBlue;
extern color               TextCol =                     White;

int      maxArrows,IndID;
double goober;
double MA1_Array[],MA2_Array[],RSI[], Trend[], TrendRSI[], TrendMA[], TMACenter[], TMAHigh[], TMALow[], Upper[], Lower[], BBUpper[], BBLower[], BBCenter[];
string PrefMainNoDelete="MainNoDelete_",PrefMainDelete="MainDelete_",PrefDealsDel="DealsDelete_",PrefDealsNoDel="DealsNoDelete_",prefix="",suffix="";
int first_time_main = 0;
bool display_status_main = TRUE;
int MainPanWasDisabled = 0;
int MainPanWasEnabled = 0;

int deinit()
   {
   DeleteArrows();
   DeleteObjectsByPrefix(PrefMainDelete);
   DeleteObjectsByPrefix(PrefMainNoDelete);
   SetLevelStyle(DRAW_NONE,0,0);
   return(0);
   }

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
if(UsePanel) 
   {
   ButtonMainPan();
   }
DeleteArrows();
//---- indicators setting
SetIndexStyle(0,DRAW_LINE,MA1_Style,MA1_Width,MA1_Color);
SetIndexStyle(1,DRAW_LINE,MA2_Style,MA2_Width,MA2_Color);
SetIndexStyle(2,DRAW_LINE,RSI_Style,RSI_Width,RSI_Color);
SetIndexStyle(3,DRAW_LINE,TMA_Style,TMA_Width,TMACenter_Color);
SetIndexStyle(4,DRAW_LINE,TMA_Style,TMA_Width,TMAHigh_Color);
SetIndexStyle(5,DRAW_LINE,TMA_Style,TMA_Width,TMALow_Color);
SetIndexStyle(6,DRAW_LINE,RSI_Style,RSI_overBought_Width,RSI_overBought_Color);
SetIndexStyle(7,DRAW_LINE,RSI_Style,RSI_overSold_Width,RSI_overSold_Color);
SetIndexStyle(8,DRAW_LINE,bb_Style,bb_Width,bb_High_Color);
SetIndexStyle(9,DRAW_LINE,bb_Style,bb_Width,bb_Low_Color);
SetIndexStyle(10,DRAW_LINE,bb_Style,bb_Width,bb_Center_Color);
IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
IndicatorShortName("Silent_RSI "+RSI_Period+" "+RSI_Timeframe);

SetIndexBuffer(0,MA1_Array);
SetIndexLabel(0,"MA1-RSI "+MA1_Period);

SetIndexBuffer(1,MA2_Array);
SetIndexLabel(1,"MA2-RSI "+MA2_Period);

SetIndexBuffer(2,RSI);
SetIndexLabel(2,"RSI "+RSI_Period);

SetIndexBuffer(3,TMACenter);
SetIndexLabel(3,"TMACenter "+DevPeriod);

SetIndexBuffer(4,TMAHigh);
SetIndexLabel(4,"TMAHigh "+DevPeriod);

SetIndexBuffer(5,TMALow);
SetIndexLabel(5,"TMALow "+DevPeriod);

SetIndexBuffer(6,Upper);
SetIndexLabel(6,"Upper "+RSI_Period);

SetIndexBuffer(7,Lower);
SetIndexLabel(7,"Lower "+RSI_Period);

SetIndexBuffer(8,BBUpper);
SetIndexLabel(8,"BBUpper "+bb_period);

SetIndexBuffer(9,BBLower);
SetIndexLabel(9,"BBLower "+bb_period);

SetIndexBuffer(10,BBCenter);
SetIndexLabel(10,"BBCenter "+bb_period);

SetIndexBuffer(11,TrendRSI);

SetIndexBuffer(12,TrendMA);

SetIndexBuffer(13,Trend);

if(Show_RSI_Levels)
   {
   IndicatorSetInteger(INDICATOR_LEVELS,5);
   IndicatorSetDouble(INDICATOR_LEVELVALUE,0,overBought);
   IndicatorSetDouble(INDICATOR_LEVELVALUE,1,overSold);
   IndicatorSetDouble(INDICATOR_LEVELVALUE,2,50);
   IndicatorSetDouble(INDICATOR_LEVELVALUE,3,MaxoverBought);
   IndicatorSetDouble(INDICATOR_LEVELVALUE,4,MaxoverSold);
   
   IndicatorSetInteger(INDICATOR_LEVELCOLOR,RSI_Levels_Color);
   IndicatorSetInteger(INDICATOR_LEVELSTYLE,RSI_Levels_Style);
   IndicatorSetInteger(INDICATOR_LEVELWIDTH,RSI_Levels_Width);
   }

IndID = makeMagicNumber("Silent_RSI "+Symbol()+IntegerToString(Period())+IntegerToString(RSI_Period)+" "+IntegerToString(RSI_Timeframe));   //  

return(0);
}

void OnChartEvent(const int id, const long &lparam, const double &dparam, const string &sparam) 
   {
   if(UsePanel)
      {
      if(id==CHARTEVENT_OBJECT_CLICK)   
         {
         string clickedChartObject=sparam;
         if (clickedChartObject==(string)PrefMainNoDelete+"ButtonMainPan") 
            {
            ButtonMainPan();
            }
         }
      }
   }

//+------------------------------------------------------------------+
//| Custom indicator iteration function |
//+------------------------------------------------------------------+
int start()
   {
   DeleteArrows();
   DeleteObjectsByPrefix(PrefMainDelete);
   if(!IsTesting()&&!IsConnected()&&UseReconnect) ReConnect();
   double ma, stdev;
   int i,j,k,counted_bars=IndicatorCounted();
   int limit=0;
   if(MaxBars==0) limit=MathMin(Bars-1,Bars-counted_bars+HalfLength);
   else limit=MaxBars;
   //---- indicator calculation
   
   if(IsNewBar(0,DataRefreshPeriod)) 
      {
      if(!IsTesting()) 
         {
         if(!ForceLoadOneSym()) return(0);
         }
      }
      
   for(i=limit; i>=0; i--)
      {
      if(RSI_Timeframe>Period()) RSI[i]= iRSI(NULL,RSI_Timeframe,RSI_Period,RSI_Applied_Price,i/(RSI_Timeframe/Period()));
      if(RSI_Timeframe==Period()||RSI_Timeframe==0) RSI[i]= iRSI(NULL,Period(),RSI_Period,RSI_Applied_Price,i);
      if(RSI_Timeframe<Period()&&RSI_Timeframe!=0) RSI[i]= iRSI(NULL,RSI_Timeframe,RSI_Period,RSI_Applied_Price,i*(Period()/RSI_Timeframe));
      }
   for(i=limit; i>=0; i--)
      {
      TrendRSI[i]= iRSI(NULL,Period(),RSI_Trend_Period,RSI_Trend_Applied_Price,i);
      }
   for(i=limit; i>=0; i--)
      { 
      if(Show_MA1) MA1_Array[i] = iMAOnArray(RSI,0,MA1_Period,MA1_Applied_Price,MA1_Method,i);
      if(Show_MA2) MA2_Array[i] = iMAOnArray(RSI,0,MA2_Period,MA2_Applied_Price,MA2_Method,i);
      TrendMA[i] = iMAOnArray(TrendRSI,0,MA_Trend_Period,MA_Trend_Applied_Price,MA_Trend_Method,i);
      }
   if(Show_TMA)
      {
      for (i=limit; i>=0; i--)
         {
         double sum  = (HalfLength+1)*RSI[i];
         double sumw = (HalfLength+1);
         for(j=1, k=HalfLength; j<=HalfLength; j++, k--)
            {
            sum  += k*RSI[i+j];
            sumw += k;
            }
         double dev  = iStdDevOnArray(RSI,0,DevPeriod,0,MODE_SMA,i);
         TMACenter[i] = sum/sumw;
         TMAHigh[i] = TMACenter[i]+dev*Deviations;
         TMALow[i] = TMACenter[i]-dev*Deviations;
         }
      }
      
   if(Show_BB)
      {
      for (i=limit; i>=0; i--)
         {
         ma=iMAOnArray(RSI,0,bb_period,0,BB_Method,i); //  
         stdev=iStdDevOnArray(RSI,0,bb_period,0,0,i); // 
         BBUpper[i]=ma+bb_dev*stdev; //  
         BBLower[i]=ma-bb_dev*stdev; //  
         BBCenter[i]=ma; // 
         }
      }
      
   for(i=limit; i>=0; i--)
      {
      if (RSI[i] > overBought) 
         { 
         Upper[i] = RSI[i]; 
         Upper[i+1] = RSI[i+1]; 
         }
      else                           
         { 
         Upper[i] = EMPTY_VALUE;
         if (Upper[i+2] == EMPTY_VALUE) Upper[i+1]  = EMPTY_VALUE; 
         }
      if (RSI[i] < overSold)   
         { 
         Lower[i] = RSI[i]; 
         Lower[i+1] = RSI[i+1]; 
         }
      else                           
         { 
         Lower[i] = EMPTY_VALUE;
         if (Lower[i+2] == EMPTY_VALUE) Lower[i+1]  = EMPTY_VALUE; 
         }
      }
      
   double Cross1,Cross2;
   for (i=0; i<limit ;i++)
      {
      if(cross50==1)
         {
         Cross1=TrendRSI[i+1];
         Cross2=TrendRSI[i+2];
         }
      if(cross50==2)
         {
         Cross1=TrendMA[i+1];
         Cross2=TrendMA[i+2];
         }
      if(Cross2>50&&Cross1<50) 
         {
         if(show50cross) DrawArrow(i,12);
         }
      if(Cross2<50&&Cross1>50) 
         {
         if(show50cross) DrawArrow(i,11);
         }
      if(Cross1<50) Trend[i]=-1;
      if(Cross1>50) Trend[i]=1;
      }

      
   if (showZoneArrows&&!showMaxZoneArrows)
      {
      for (i=0; i<limit ;i++)
         {
         if (RSI[i+2]>overBought&&RSI[i+1]<overBought&&((UseTrendFiltration&&Trend[i]==-1)||!UseTrendFiltration)) DrawArrow(i,1);
         if (RSI[i+2]<overSold&&RSI[i+1]>overSold&&((UseTrendFiltration&&Trend[i]==1)||!UseTrendFiltration))   DrawArrow(i,2);
         }
      }
   if(showZoneArrows&&showMaxZoneArrows)
      {
      for (i=0; i<limit ;i++)
         {
         if (RSI[i+2]>overBought&&(RSI[i+2]<MaxoverBought||RSI[i+3]<MaxoverBought||RSI[i+4]<MaxoverBought)&&RSI[i+1]<overBought&&((UseTrendFiltration&&Trend[i]==-1)||!UseTrendFiltration)) DrawArrow(i,1);
         if (RSI[i+2]<overSold&&(RSI[i+2]>MaxoverSold||RSI[i+3]>MaxoverSold||RSI[i+4]>MaxoverSold)&&RSI[i+1]>overSold&&((UseTrendFiltration&&Trend[i]==1)||!UseTrendFiltration))   DrawArrow(i,2);
         if (RSI[i+2]>MaxoverBought&&RSI[i+1]<overBought&&((UseTrendFiltration&&Trend[i]==-1)||!UseTrendFiltration)) DrawArrow(i,3);
         if (RSI[i+2]<MaxoverSold&& RSI[i+1]>overSold&&((UseTrendFiltration&&Trend[i]==1)||!UseTrendFiltration))   DrawArrow(i,4);
         }
      }
   if(showMaxZoneArrows&&!showZoneArrows)
      {
      for (i=0; i<limit ;i++)
         {
         if (RSI[i+2]>MaxoverBought&&RSI[i+1]<overBought&&((UseTrendFiltration&&Trend[i]==-1)||!UseTrendFiltration)) DrawArrow(i,3);
         if (RSI[i+2]<MaxoverSold&& RSI[i+1]>overSold&&((UseTrendFiltration&&Trend[i]==1)||!UseTrendFiltration))   DrawArrow(i,4);
         }
      }
   if (showMACrossArrows)
      {
      for (i=0; i<limit ;i++)
         {
         if(Show_MA1&&Show_MA2)
            {
            if(MA1_Period>MA2_Period)
               {
               if((Show_TMA&&Show_BB)||(Show_TMA&&!Show_BB))
                  {
                  if(MA1_Array[i+2]>MA2_Array[i+2]&&MA1_Array[i+1]<MA2_Array[i+1]&&MA1_Array[i+2]<TMACenter[i+2]&&MA2_Array[i+2]<TMACenter[i+2]&&((UseTrendFiltration&&Trend[i]==1)||!UseTrendFiltration)) DrawArrow(i,6);
                  if(MA1_Array[i+2]<MA2_Array[i+2]&&MA1_Array[i+1]>MA2_Array[i+1]&&MA1_Array[i+2]>TMACenter[i+2]&&MA2_Array[i+2]>TMACenter[i+2]&&((UseTrendFiltration&&Trend[i]==-1)||!UseTrendFiltration)) DrawArrow(i,5);
                  }
               if(Show_BB&&!Show_TMA)
                  {
                  if(MA1_Array[i+2]>MA2_Array[i+2]&&MA1_Array[i+1]<MA2_Array[i+1]&&MA1_Array[i+2]<BBCenter[i+2]&&MA2_Array[i+2]<BBCenter[i+2]&&((UseTrendFiltration&&Trend[i]==1)||!UseTrendFiltration)) DrawArrow(i,6);
                  if(MA1_Array[i+2]<MA2_Array[i+2]&&MA1_Array[i+1]>MA2_Array[i+1]&&MA1_Array[i+2]>BBCenter[i+2]&&MA2_Array[i+2]>BBCenter[i+2]&&((UseTrendFiltration&&Trend[i]==-1)||!UseTrendFiltration)) DrawArrow(i,5);
                  }
               if(!Show_BB&&!Show_TMA)
                  {
                  if(MA1_Array[i+2]>MA2_Array[i+2]&&MA1_Array[i+1]<MA2_Array[i+1]&&MA1_Array[i+2]<50&&MA2_Array[i+2]<50&&((UseTrendFiltration&&Trend[i]==1)||!UseTrendFiltration)) DrawArrow(i,6);
                  if(MA1_Array[i+2]<MA2_Array[i+2]&&MA1_Array[i+1]>MA2_Array[i+1]&&MA1_Array[i+2]>50&&MA2_Array[i+2]>50&&((UseTrendFiltration&&Trend[i]==-1)||!UseTrendFiltration)) DrawArrow(i,5);
                  }
               }
            if(MA1_Period<MA2_Period)
               {
               if((Show_TMA&&Show_BB)||(Show_TMA&&!Show_BB))
                  {
                  if(MA1_Array[i+2]<MA2_Array[i+2]&&MA1_Array[i+1]>MA2_Array[i+1]&&MA1_Array[i+2]<TMACenter[i+2]&&MA2_Array[i+2]<TMACenter[i+2]&&((UseTrendFiltration&&Trend[i]==1)||!UseTrendFiltration)) DrawArrow(i,6);
                  if(MA1_Array[i+2]>MA2_Array[i+2]&&MA1_Array[i+1]<MA2_Array[i+1]&&MA1_Array[i+2]>TMACenter[i+2]&&MA2_Array[i+2]>TMACenter[i+2]&&((UseTrendFiltration&&Trend[i]==-1)||!UseTrendFiltration)) DrawArrow(i,5);
                  }
               if(Show_BB&&!Show_TMA)
                  {
                  if(MA1_Array[i+2]<MA2_Array[i+2]&&MA1_Array[i+1]>MA2_Array[i+1]&&MA1_Array[i+2]<BBCenter[i+2]&&MA2_Array[i+2]<BBCenter[i+2]&&((UseTrendFiltration&&Trend[i]==1)||!UseTrendFiltration)) DrawArrow(i,6);
                  if(MA1_Array[i+2]>MA2_Array[i+2]&&MA1_Array[i+1]<MA2_Array[i+1]&&MA1_Array[i+2]>BBCenter[i+2]&&MA2_Array[i+2]>BBCenter[i+2]&&((UseTrendFiltration&&Trend[i]==-1)||!UseTrendFiltration)) DrawArrow(i,5);
                  }
               if(!Show_BB&&!Show_TMA)
                  {
                  if(MA1_Array[i+2]<MA2_Array[i+2]&&MA1_Array[i+1]>MA2_Array[i+1]&&MA1_Array[i+2]<50&&MA2_Array[i+2]<50&&((UseTrendFiltration&&Trend[i]==1)||!UseTrendFiltration)) DrawArrow(i,6);
                  if(MA1_Array[i+2]>MA2_Array[i+2]&&MA1_Array[i+1]<MA2_Array[i+1]&&MA1_Array[i+2]>50&&MA2_Array[i+2]>50&&((UseTrendFiltration&&Trend[i]==-1)||!UseTrendFiltration)) DrawArrow(i,5);
                  }
               }
            }
         if(Show_MA1&&!Show_MA2)
            {
            if((Show_TMA&&Show_BB)||(Show_TMA&&!Show_BB))
               {
               if(MA1_Array[i+2]>RSI[i+2]&&MA1_Array[i+1]<RSI[i+1]&&MA1_Array[i+2]<TMACenter[i+2]&&RSI[i+2]<TMACenter[i+2]&&((UseTrendFiltration&&Trend[i]==1)||!UseTrendFiltration)) DrawArrow(i,6);
               if(MA1_Array[i+2]<RSI[i+2]&&MA1_Array[i+1]>RSI[i+1]&&MA1_Array[i+2]>TMACenter[i+2]&&RSI[i+2]>TMACenter[i+2]&&((UseTrendFiltration&&Trend[i]==-1)||!UseTrendFiltration)) DrawArrow(i,5);
               }
            if(Show_BB&&!Show_TMA)
               {
               if(MA1_Array[i+2]>RSI[i+2]&&MA1_Array[i+1]<RSI[i+1]&&MA1_Array[i+2]<BBCenter[i+2]&&RSI[i+2]<BBCenter[i+2]&&((UseTrendFiltration&&Trend[i]==1)||!UseTrendFiltration)) DrawArrow(i,6);
               if(MA1_Array[i+2]<RSI[i+2]&&MA1_Array[i+1]>RSI[i+1]&&MA1_Array[i+2]>BBCenter[i+2]&&RSI[i+2]>BBCenter[i+2]&&((UseTrendFiltration&&Trend[i]==-1)||!UseTrendFiltration)) DrawArrow(i,5);
               }
            if(!Show_BB&&!Show_TMA)
               {
               if(MA1_Array[i+2]>RSI[i+2]&&MA1_Array[i+1]<RSI[i+1]&&MA1_Array[i+2]<50&&RSI[i+2]<50&&((UseTrendFiltration&&Trend[i]==1)||!UseTrendFiltration)) DrawArrow(i,6);
               if(MA1_Array[i+2]<RSI[i+2]&&MA1_Array[i+1]>RSI[i+1]&&MA1_Array[i+2]>50&&RSI[i+2]>50&&((UseTrendFiltration&&Trend[i]==-1)||!UseTrendFiltration)) DrawArrow(i,5);
               }
            }
         if(Show_MA2&&!Show_MA1)
            {
            if((Show_TMA&&Show_BB)||(Show_TMA&&!Show_BB))
               {
               if(MA2_Array[i+2]>RSI[i+2]&&MA2_Array[i+1]<RSI[i+1]&&MA2_Array[i+2]<TMACenter[i+2]&&RSI[i+2]<TMACenter[i+2]&&((UseTrendFiltration&&Trend[i]==1)||!UseTrendFiltration)) DrawArrow(i,6);
               if(MA2_Array[i+2]<RSI[i+2]&&MA2_Array[i+1]>RSI[i+1]&&MA2_Array[i+2]>TMACenter[i+2]&&RSI[i+2]>TMACenter[i+2]&&((UseTrendFiltration&&Trend[i]==-1)||!UseTrendFiltration)) DrawArrow(i,5);
               }
            if(Show_BB&&!Show_TMA)
               {
               if(MA2_Array[i+2]>RSI[i+2]&&MA2_Array[i+1]<RSI[i+1]&&MA2_Array[i+2]<BBCenter[i+2]&&RSI[i+2]<BBCenter[i+2]&&((UseTrendFiltration&&Trend[i]==1)||!UseTrendFiltration)) DrawArrow(i,6);
               if(MA2_Array[i+2]<RSI[i+2]&&MA2_Array[i+1]>RSI[i+1]&&MA2_Array[i+2]>BBCenter[i+2]&&RSI[i+2]>BBCenter[i+2]&&((UseTrendFiltration&&Trend[i]==-1)||!UseTrendFiltration)) DrawArrow(i,5);
               }
            if(!Show_BB&&!Show_TMA)
               {
               if(MA2_Array[i+2]>RSI[i+2]&&MA2_Array[i+1]<RSI[i+1]&&MA2_Array[i+2]<50&&RSI[i+2]<50&&((UseTrendFiltration&&Trend[i]==1)||!UseTrendFiltration)) DrawArrow(i,6);
               if(MA2_Array[i+2]<RSI[i+2]&&MA2_Array[i+1]>RSI[i+1]&&MA2_Array[i+2]>50&&RSI[i+2]>50&&((UseTrendFiltration&&Trend[i]==-1)||!UseTrendFiltration)) DrawArrow(i,5);
               }
            }
         }
      }
   if(showDiv)
      {
      k=0;
      for (i=0; i<limit ;i++)
         {
         if(RSI[i+2]>overBought&&RSI[i+1]<overBought&&((UseTrendFiltration&&Trend[i]==-1)||!UseTrendFiltration))
            {
            for(k=i+7;k>i+1;k--)
               {
               if(RSI[k]>overBought&&RSI[k]>RSI[k+1]&&RSI[k]>RSI[k-1]&&RSI[k]>RSI[k+2]&&RSI[k]>RSI[k-2])
                  {
                  if(RSI[k]<RSI[k+3]||RSI[k]<RSI[k+4]||RSI[k]<RSI[k+5]||RSI[k]<RSI[k+6])
                     {
                     DrawArrow(i,7);
                     break;
                     }
                  }
               }
            }
         if(RSI[i+2]<overSold&& RSI[i+1]>overSold&&((UseTrendFiltration&&Trend[i]==1)||!UseTrendFiltration))
            {
            for(k=i+7;k>i+1;k--)
               {
               if(RSI[k]<overSold&&RSI[k]<RSI[k+1]&&RSI[k]<RSI[k-1]&&RSI[k]<RSI[k+2]&&RSI[k]<RSI[k-2])
                  {
                  if(RSI[k]>RSI[k+3]||RSI[k]>RSI[k+4]||RSI[k]>RSI[k+5]||RSI[k]>RSI[k+6])
                     {
                     DrawArrow(i,8);
                     break;
                     }
                  }
               }
            }
         }
      }
   if(showChannelArrow)
      {
      for (i=0; i<limit ;i++)
         {
         if((Show_TMA&&!Show_BB)||(Show_TMA&&Show_BB))
            {
            if(RSI[i+2]>TMAHigh[i+2]&&RSI[i+1]<TMAHigh[i+1]&&((UseTrendFiltration&&Trend[i]==-1)||!UseTrendFiltration)) DrawArrow(i,9);
            if(RSI[i+2]<TMALow[i+2]&&RSI[i+1]>TMALow[i+1]&&((UseTrendFiltration&&Trend[i]==1)||!UseTrendFiltration)) DrawArrow(i,10);
            }
         if(Show_BB&&!Show_TMA)
            {
            if(RSI[i+2]>BBUpper[i+2]&&RSI[i+1]<BBUpper[i+1]&&((UseTrendFiltration&&Trend[i]==-1)||!UseTrendFiltration)) DrawArrow(i,9);
            if(RSI[i+2]<BBLower[i+2]&&RSI[i+1]>BBLower[i+1]&&((UseTrendFiltration&&Trend[i]==1)||!UseTrendFiltration)) DrawArrow(i,10);
            }
         }
      }
   if(UsePanel)
      {
      ButtonMainPan();
      }
//----
return(0);
}
//+------------------------------------------------------------------+


void DrawArrow(int i,int type)
   {
   string SignalName=" ";
   if(i==1&&type!=0)
      {
      if(type==1) SignalName="    (RSI  ),  : 1";
      if(type==2) SignalName="    (RSI  ),  : 1";
      if(type==3) SignalName="    (RSI  . ),  : 2";
      if(type==4) SignalName="   , (RSI  . )  : 2";
      if(type==5) SignalName="    ( ),  : 3";
      if(type==6) SignalName="    ( ),  : 3";
      if(type==7) SignalName="    ( ),  : 4";
      if(type==8) SignalName="    ( ),  : 4";
      if(type==9) SignalName="    (RSI  ),  : 5";
      if(type==10) SignalName="    (RSI  ),  : 5";
      if(type==11) SignalName="   ,  : 6";
      if(type==12) SignalName="   ,  : 6";
      if (Play_Alert&&SignalName!=" ")
         {
         if (goober<Time[0])
            {
            Alert(SignalName);
            if(Play_Sound) PlaySound("email.wav");
            goober = Time[0];
            }
         }
      MakeScreenshot("RSISignal"+IntegerToString(IndID)+type);
      MailSend("RSISignal"+IntegerToString(IndID)+type);
      SendPush("RSISignal"+IntegerToString(IndID)+type);
      }
   maxArrows++;
   ObjectCreate("RSISignal"+IntegerToString(IndID)+maxArrows,OBJ_ARROW,0,Time[i],0);
   if (type==1)
      {
      ObjectSet("RSISignal"+IntegerToString(IndID)+maxArrows,OBJPROP_PRICE1,High[i+1]+(ArrowDelta*Point));
      ObjectSet("RSISignal"+IntegerToString(IndID)+maxArrows,OBJPROP_ARROWCODE,140);
      ObjectSet("RSISignal"+IntegerToString(IndID)+maxArrows,OBJPROP_COLOR,ZoneArrows_Dn_Color);
      }
   if (type==2)
      {
      ObjectSet("RSISignal"+IntegerToString(IndID)+maxArrows,OBJPROP_PRICE1,Low[i+1]-(ArrowDelta*Point));
      ObjectSet("RSISignal"+IntegerToString(IndID)+maxArrows,OBJPROP_ARROWCODE,140);
      ObjectSet("RSISignal"+IntegerToString(IndID)+maxArrows,OBJPROP_COLOR,ZoneArrows_Up_Color);
      }
   if (type==4)
      {
      ObjectSet("RSISignal"+IntegerToString(IndID)+maxArrows,OBJPROP_PRICE1,Low[i+1]-(ArrowDelta*Point));
      ObjectSet("RSISignal"+IntegerToString(IndID)+maxArrows,OBJPROP_ARROWCODE,141);
      ObjectSet("RSISignal"+IntegerToString(IndID)+maxArrows,OBJPROP_COLOR,MaxZoneArrows_Up_Color);
      }
   if (type==3)
      {
      ObjectSet("RSISignal"+IntegerToString(IndID)+maxArrows,OBJPROP_PRICE1,High[i+1]+(ArrowDelta*Point));
      ObjectSet("RSISignal"+IntegerToString(IndID)+maxArrows,OBJPROP_ARROWCODE,141);
      ObjectSet("RSISignal"+IntegerToString(IndID)+maxArrows,OBJPROP_COLOR,MaxZoneArrows_Dn_Color);
      }
   if (type==6)
      {
      ObjectSet("RSISignal"+IntegerToString(IndID)+maxArrows,OBJPROP_PRICE1,Low[i+1]-(ArrowDelta*Point));
      ObjectSet("RSISignal"+IntegerToString(IndID)+maxArrows,OBJPROP_ARROWCODE,142);
      ObjectSet("RSISignal"+IntegerToString(IndID)+maxArrows,OBJPROP_COLOR,MACrossArrows_Up_Color);
      }
   if (type==5)
      {
      ObjectSet("RSISignal"+IntegerToString(IndID)+maxArrows,OBJPROP_PRICE1,High[i+1]+(ArrowDelta*Point));
      ObjectSet("RSISignal"+IntegerToString(IndID)+maxArrows,OBJPROP_ARROWCODE,142);
      ObjectSet("RSISignal"+IntegerToString(IndID)+maxArrows,OBJPROP_COLOR,MACrossArrows_Dn_Color);
      }
   if (type==8)
      {
      ObjectSet("RSISignal"+IntegerToString(IndID)+maxArrows,OBJPROP_PRICE1,Low[i+1]-(ArrowDelta*Point));
      ObjectSet("RSISignal"+IntegerToString(IndID)+maxArrows,OBJPROP_ARROWCODE,143);
      ObjectSet("RSISignal"+IntegerToString(IndID)+maxArrows,OBJPROP_COLOR,Div_Up_Color);
      }
   if (type==7)
      {
      ObjectSet("RSISignal"+IntegerToString(IndID)+maxArrows,OBJPROP_PRICE1,High[i+1]+(ArrowDelta*Point));
      ObjectSet("RSISignal"+IntegerToString(IndID)+maxArrows,OBJPROP_ARROWCODE,143);
      ObjectSet("RSISignal"+IntegerToString(IndID)+maxArrows,OBJPROP_COLOR,Div_Dn_Color);
      }
   if (type==10)
      {
      ObjectSet("RSISignal"+IntegerToString(IndID)+maxArrows,OBJPROP_PRICE1,Low[i+1]-(ArrowDelta*Point));
      ObjectSet("RSISignal"+IntegerToString(IndID)+maxArrows,OBJPROP_ARROWCODE,144);
      ObjectSet("RSISignal"+IntegerToString(IndID)+maxArrows,OBJPROP_COLOR,Channel_Up_Color);
      }
   if (type==9)
      {
      ObjectSet("RSISignal"+IntegerToString(IndID)+maxArrows,OBJPROP_PRICE1,High[i+1]+(ArrowDelta*Point));
      ObjectSet("RSISignal"+IntegerToString(IndID)+maxArrows,OBJPROP_ARROWCODE,144);
      ObjectSet("RSISignal"+IntegerToString(IndID)+maxArrows,OBJPROP_COLOR,Channel_Dn_Color);
      }
   if (type==11)
      {
      ObjectSet("RSISignal"+IntegerToString(IndID)+maxArrows,OBJPROP_PRICE1,Low[i+1]-(ArrowDelta*Point));
      ObjectSet("RSISignal"+IntegerToString(IndID)+maxArrows,OBJPROP_ARROWCODE,145);
      ObjectSet("RSISignal"+IntegerToString(IndID)+maxArrows,OBJPROP_COLOR,cross50_Up_Color);
      }
   if (type==12)
      {
      ObjectSet("RSISignal"+IntegerToString(IndID)+maxArrows,OBJPROP_PRICE1,High[i+1]+(ArrowDelta*Point));
      ObjectSet("RSISignal"+IntegerToString(IndID)+maxArrows,OBJPROP_ARROWCODE,145);
      ObjectSet("RSISignal"+IntegerToString(IndID)+maxArrows,OBJPROP_COLOR,cross50_Dn_Color);
      }
   }

void DeleteArrows()
   {
   while(maxArrows>0) { ObjectDelete("RSISignal"+IntegerToString(IndID)+maxArrows); maxArrows--; }
   }

//+------------------------------------------------------------------+
//|  New bar function                                                |
//+------------------------------------------------------------------+
bool IsNewBar(int mode=0,int period=0)
   {
   //0 -     true
   //1 -      
   static datetime tm[10];
   int t=tfA(period);
   if(tm[t]==0&&mode==1) tm[t]=iTime(Symbol(),period,0);
   if(tm[t]==iTime(Symbol(),period,0)) return (false);
   tm[t]=iTime(Symbol(),period,0);
   return (true);
   }
 
int tfA(int tf)
   {
   switch (tf)
      {
      case PERIOD_M1: return (0);
      case PERIOD_M5: return (1);
      case PERIOD_M15: return (2);
      case PERIOD_M30: return (3);
      case PERIOD_H1: return (4);
      case PERIOD_H4: return (5);
      case PERIOD_D1: return (6);
      case PERIOD_W1: return (7);
      case PERIOD_MN1: return (8);
      default: return (9);
      }
   }
   
//+------------------------------------------------------------------+
//| Force load historical data function                              |
//+------------------------------------------------------------------+
bool ForceLoadOneSym() 
   {
   //attempt to force-load one symbol. Return false if any iBars() return false
   //comes out to be zero, could be waiting for download
    int timeFrames[] = {PERIOD_M1,PERIOD_M5,PERIOD_M15,PERIOD_M30,PERIOD_H1,
                         PERIOD_H4,PERIOD_D1,PERIOD_W1, PERIOD_MN1};
    int ntf = ArraySize(timeFrames);
    bool OK=true;
    string s=Symbol()+" NumBars(TF): ";
    for (int j=0; j < ntf; j++) 
      {
      int tf = timeFrames[j];
      RefreshRates();
      int bars=barsWithRetry(Symbol(),tf);
      bool tfOK=true;
      if (bars == 0) 
         {
         tfOK = false;
         }
      double z = iClose(Symbol(),tf,0);
      if (z == 0.0) 
         {
         tfOK = false;
         }
      double y = iMA(Symbol(),tf,1,0,MODE_SMA,PRICE_MEDIAN,0);
      if (y == 0.0) 
         {
         tfOK = false;
         }
      s = s + bars+"("+tf+") ";
      if (!tfOK) 
         {
         OK=false; 
         }
      if(tfOK) Print("ForceLoadOneSym function: Loaded "+tf+" data");
      }
    if (OK) 
      {
      Print("ForceLoadOneSym function: Success load historical data: "+s);
      } 
    else 
      {
      Print("ForceLoadOneSym function: Fail to load historical data: "+s); 
      }
   return(OK);
   }
   
//+------------------------------------------------------------------+
//| Counts ammount of bars on chart nedeed TF                        |
//+------------------------------------------------------------------+
int barsWithRetry(string TempSymbol, int tf) 
   {
   int bars=0;
   for (int i=0; i < RetryAttempts; i++) 
      {
      bars=iBars(TempSymbol,tf);
      if (bars > 0) 
         {
         return(bars);
         }  
      int err=GetLastError();
      if (err != 4066) 
         {
         return(0); 
         } 
      else 
         {
         Sleep(3000);  
         }
      }
      return(0); 
   }
   
//+------------------------------------------------------------------+
//| Magic generation                                                 |
//+------------------------------------------------------------------+
int makeMagicNumber(string key)
{
int i,n;
int h = 0;
if (IsTesting()) 
   {
   key = "_" + key;
   }
for (i = 0; i < StringLen(key); i++) 
   {
   n = StringGetChar(key, i);
   h = h + n;
   h = bitRotate(h, 5);
   }
for (i = 0; i < StringLen(key); i++) 
   {
   n = StringGetChar(key, i);
   h = h + n;
   h = bitRotate(h, n & 0x0000000F);
   }
for (i = StringLen(key); i > 0; i--) 
   {
   n = StringGetChar(key, i - 1);
   h = h + n;
   h = bitRotate(h, h & 0x0000000F);
   }
return(h & 0x7fffffff);
}

int bitRotate(int value, int count) 
   {
   int tmp, mask;
   mask = (0x00000001 << count) - 1;
   tmp = value & mask;
   value = value >> count;
   value = value | (tmp << (32 - count));
   return(value);
   }
   
void MakeScreenshot(string st)
   {
   if(UseSnapShot)
      {
      string name=TimeToStr(TimeLocal(), TIME_DATE)+" "+st+".gif";
      ChartScreenShot(0,name, 640, 480, ALIGN_RIGHT);
      }
   }
   
void MailSend(string st)
   {
   if (UseSendMail)
      {
      SendMail(WindowExpertName(), TimeToStr(TimeLocal(), TIME_DATE)+": "+st);
      }
   }
   
void SendPush(string st)
   {
   if (UseSendPush) 
      {
      SendNotification(TimeToStr(TimeLocal(), TIME_DATE)+": "+st);
      }
   }
 
//+------------------------------------------------------------------+
//|  Server rescan and reconnect                                     |
//+------------------------------------------------------------------+
void ReConnect()
   {
   if((!IsTesting() && !IsOptimization()&&!IsConnected()&&!IsStopped())||GetLastError()==6) 
      {
      Alert("ReConnect function: Connection lost! Rescan servers...");
      for (int i=1;i<=RetryAttempts;i++) 
         {
         ReScanServers();
         if(IsConnected()) break;
         Sleep(10000);
         RefreshRates();
         }
      if(IsConnected()) Alert("ReConnect function: Connection found!");
      else ReLoginAccount();
      }
   return;
   }
   
int ReScanServers()
   {
   int hwindow=GetAncestor(WindowHandle(Symbol(),Period()),2);
   Alert("ReScanServers function: Rescan servers...");
   if(hwindow!=0) 
      {
      return(PostMessageA(hwindow,WM_COMMAND,37400,0)); 
      }
   return(-1);
   }
   
void ReLoginAccount()
   {
   int hwnd=GetAncestor(WindowHandle(Symbol(),Period()),2);
   Alert("ReLoginAccount function: Relogin...");
   PostMessageA(hwnd,WM_COMMAND,35429,0);
   Sleep(5000);
   hwnd=GetLastActivePopup(hwnd);
   hwnd=GetDlgItem(hwnd,0x1);
   Sleep(5000);
   SendMessageA(hwnd,BM_CLICK,0,0);
   return;
   }
   
void ButtonMainPan() 
   {
   if (first_time_main == 0||ObjectFind(0,PrefMainNoDelete+"ButtonMainPan")==-1) 
      {
      ButtonCreate(0,PrefMainNoDelete+"ButtonMainPan",0,15,15,20,20,0,"-","Arial",12,clrBlack,C'236,233,216'); //  
      RectLabelCreate(0,PrefMainNoDelete+"MainPanHeader",0,36,15,160,20,DimGray,LightSlateGray,STYLE_SOLID,2,true,false);
      LabelCreate(0,PrefMainNoDelete+"MainPanHeaderText",0,40,16,CORNER_LEFT_UPPER,"Silent_RSI "+RSI_Period+" "+RSI_Timeframe+" "+Symbol(),
                  "Arial",10,White,0.0,ANCHOR_LEFT_UPPER,false,false,false,0);
      first_time_main = 1;
      }

   if (but_stat(PrefMainNoDelete+"ButtonMainPan")) 
      {
      display_status_main = !display_status_main;
      button_off(PrefMainNoDelete+"ButtonMainPan");                                                                       //   
      }

   if (display_status_main) 
      {
      ShowMainMenu(1);
      MainPanWasEnabled=1;
      }
      else 
         {
         ShowMainMenu(-1);
         MainPanWasDisabled=1;
         }
   }

void ShowMainMenu(int key)
   {
   DeleteObjectsByPrefix(PrefMainDelete);
   string Text="";
   color TheColor=Black;
   if (key > 0) 
      {
      RectLabelCreate(0,PrefMainDelete + "MainPanBodyName",0,36,40,160,210,SlateGray,LightSlateGray,STYLE_SOLID,2,true,false);
      string TrendName;
      if(Trend[1]==0) TrendName=" ";
      if(Trend[1]==1) TrendName="";
      if(Trend[1]==-1) TrendName="";
      LabelCreate(0,PrefMainDelete + "MainPanBodyTrend",0,40,40,CORNER_LEFT_UPPER," : "+TrendName,
                  "Arial",10,TextCol,0.0,ANCHOR_LEFT_UPPER,false,false,false,0);
      if(MA1_Array[1]>1000) Text="";
      if(MA1_Array[1]<1000) Text=DoubleToString(MA1_Array[1],2);
      LabelCreate(0,PrefMainDelete + "MainPanBodyMA1_Array",0,40,60,CORNER_LEFT_UPPER," 1: "+Text,
                  "Arial",10,TextCol,0.0,ANCHOR_LEFT_UPPER,false,false,false,0);
      if(MA2_Array[1]>1000) Text="";
      if(MA2_Array[1]<1000) Text=DoubleToString(MA2_Array[1],2);
      LabelCreate(0,PrefMainDelete + "MainPanBodyMA2_Array",0,40,80,CORNER_LEFT_UPPER," 2: "+Text,
                  "Arial",10,TextCol,0.0,ANCHOR_LEFT_UPPER,false,false,false,0);
      if(RSI[1]==0) Text="";
      if(RSI[1]!=0) Text=DoubleToString(RSI[1],2);      
      LabelCreate(0,PrefMainDelete + "MainPanBodyRSI",0,40,100,CORNER_LEFT_UPPER,"RSI: "+Text,
                  "Arial",10,TextCol,0.0,ANCHOR_LEFT_UPPER,false,false,false,0);
      if(TMACenter[1]>1000) Text="";
      if(TMACenter[1]<1000) Text=DoubleToString(TMACenter[1],2);   
      LabelCreate(0,PrefMainDelete + "MainPanBodyTMACenter",0,40,120,CORNER_LEFT_UPPER," TMA: "+Text,
                  "Arial",10,TextCol,0.0,ANCHOR_LEFT_UPPER,false,false,false,0);
      if(TMAHigh[1]>1000) Text="";
      if(TMAHigh[1]<1000) Text=DoubleToString(TMAHigh[1],2); 
      LabelCreate(0,PrefMainDelete + "MainPanBodyTMAHigh",0,40,140,CORNER_LEFT_UPPER," TMA: "+Text,
                  "Arial",10,TextCol,0.0,ANCHOR_LEFT_UPPER,false,false,false,0);
      if(TMALow[1]>1000) Text="";
      if(TMALow[1]<1000) Text=DoubleToString(TMALow[1],2); 
      LabelCreate(0,PrefMainDelete + "MainPanBodyTMALow",0,40,160,CORNER_LEFT_UPPER," TMA: "+Text,
                  "Arial",10,TextCol,0.0,ANCHOR_LEFT_UPPER,false,false,false,0);
      if(BBCenter[1]>1000) Text="";
      if(BBCenter[1]<1000) Text=DoubleToString(BBCenter[1],2); 
      LabelCreate(0,PrefMainDelete + "MainPanBodyBBCenter",0,40,180,CORNER_LEFT_UPPER," : "+Text,
                  "Arial",10,TextCol,0.0,ANCHOR_LEFT_UPPER,false,false,false,0);
      if(BBUpper[1]>1000) Text="";
      if(BBUpper[1]<1000) Text=DoubleToString(BBUpper[1],2); 
      LabelCreate(0,PrefMainDelete + "MainPanBodyBBUpper",0,40,200,CORNER_LEFT_UPPER," : "+Text,
                  "Arial",10,TextCol,0.0,ANCHOR_LEFT_UPPER,false,false,false,0);
      if(BBLower[1]>1000) Text="";
      if(BBLower[1]<1000) Text=DoubleToString(BBLower[1],2); 
      LabelCreate(0,PrefMainDelete + "MainPanBodyBBLower",0,40,220,CORNER_LEFT_UPPER," : "+Text,
                  "Arial",10,TextCol,0.0,ANCHOR_LEFT_UPPER,false,false,false,0);
      } 
   else 
      {
      DeleteObjectsByPrefix(PrefMainDelete);
      }
   }

//+------------------------------------------------------------------+
//|                                    |
//+------------------------------------------------------------------+
bool but_stat(string name)
  {
   if(ObjectGetInteger(0,name,OBJPROP_STATE)==true)
      return true;
   return false;
  }
//+------------------------------------------------------------------+
//|                            |
//+------------------------------------------------------------------+
bool button_off(string name)  
   {
   if(ObjectSetInteger(0,name,OBJPROP_STATE,false)==true)
      return true;   return false;
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool ButtonCreate(const long              chart_ID=0,// ID 
                  string                  name="Button",//  
                  const int               sub_window=0,//  
                  const int               xx=0,                      //    X
                  const int               yy=0,                      //    Y
                  const int               width=50,                 //  
                  const int               height=18,                //  
                  const ENUM_BASE_CORNER  corner=CORNER_LEFT_UPPER, //    
                  const string            text="Button",            // 
                  const string            font="Arial",             // 
                  const int               font_size=10,             //  
                  const color             clr=clrBlack,             //  
                  const color             back_clr=C'236,233,216',  //  
                  const color             border_clr=clrNONE,       //  
                  const bool              state=false,              // /
                  const bool              back=false,               //   
                  const bool              selection=false,          //   
                  const bool              hidden=false,              //    
                  const long              z_order=0,                //    
                  const string            toltip="")
  {
   ResetLastError();
   if (ObjectFind(chart_ID,name)==-1) {
      if(ObjectCreate(chart_ID,name,OBJ_BUTTON,sub_window,0,0)) {
         ObjectSetInteger(chart_ID,name,OBJPROP_SELECTABLE,selection);     //---  (true)   (false)    
         ObjectSetInteger(chart_ID,name,OBJPROP_SELECTED,selection);
         ObjectSetInteger(chart_ID,name,OBJPROP_CORNER,corner);
      }
      ObjectSetInteger(chart_ID,name,OBJPROP_COLOR,clr);                //---   
      ObjectSetInteger(chart_ID,name,OBJPROP_BGCOLOR,back_clr);         //---   
      ObjectSetInteger(chart_ID,name,OBJPROP_BORDER_COLOR,border_clr);//---   ,      
      ObjectSetInteger(chart_ID,name,OBJPROP_XSIZE,width);              //---   
      ObjectSetInteger(chart_ID,name,OBJPROP_YSIZE,height);
      ObjectSetString(chart_ID,name,OBJPROP_FONT,font);                 //---   
      ObjectSetInteger(chart_ID,name,OBJPROP_FONTSIZE,font_size);       //---   
      ObjectSetInteger(chart_ID,name,OBJPROP_BACK,back);                //---    (false)   (true) 
      ObjectSetInteger(chart_ID,name,OBJPROP_HIDDEN,hidden);            //---  (true)   (false)      
      ObjectSetInteger(chart_ID,name,OBJPROP_ZORDER,z_order);           //---         
      ObjectSetString(chart_ID,name,OBJPROP_TOOLTIP,toltip);                 //---     
   }
   ObjectSetInteger(chart_ID,name,OBJPROP_XDISTANCE,xx);
   ObjectSetInteger(chart_ID,name,OBJPROP_YDISTANCE,yy);
   ObjectSetString(chart_ID,name,OBJPROP_TEXT,text);                 //---  
   return(true);
}



//--------------------------------------------------------------------
bool RectLabelCreate(const long             chart_ID=0,               // ID 
                     const string           name="RectLabel",         //  
                     const int              sub_window=0,             //  
                     const long             x=0,                      //    X
                     const long             y=0,                      //    y
                     const int              width=50,                 // 
                     const int              height=18,                // 
                     const color            back_clr=clrNONE,         //  
                     const color            clr=clrNONE,              //    (Flat)
                     const ENUM_LINE_STYLE  style=STYLE_SOLID,        //   
                     const int              line_width=1,             //   
                     const bool             back=true,                //   
                     const bool             selection=false,          //   
                     const bool             hidden=false,             //    
                     const long             z_order=0)                //    
  {
   ResetLastError();
   if (ObjectFind(chart_ID,name)==-1)
   {
      ObjectCreate(chart_ID,name,OBJ_RECTANGLE_LABEL,sub_window,0,0);
      ObjectSetInteger(chart_ID,name,OBJPROP_BORDER_TYPE,BORDER_FLAT);
      ObjectSetInteger(chart_ID,name,OBJPROP_CORNER,CORNER_LEFT_UPPER);
      ObjectSetInteger(chart_ID,name,OBJPROP_STYLE,style);
      ObjectSetInteger(chart_ID,name,OBJPROP_WIDTH,line_width);
      ObjectSetInteger(chart_ID,name,OBJPROP_BACK,back);
      ObjectSetInteger(chart_ID,name,OBJPROP_SELECTABLE,selection);
      ObjectSetInteger(chart_ID,name,OBJPROP_SELECTED,selection);
      ObjectSetInteger(chart_ID,name,OBJPROP_HIDDEN,hidden);
      ObjectSetInteger(chart_ID,name,OBJPROP_ZORDER,z_order);
   }
   ObjectSetInteger(chart_ID,name,OBJPROP_BGCOLOR,back_clr);
   ObjectSetInteger(chart_ID,name,OBJPROP_COLOR,clr);
   ObjectSetInteger(chart_ID,name,OBJPROP_XSIZE,width);
   ObjectSetInteger(chart_ID,name,OBJPROP_YSIZE,height);
   ObjectSetInteger(chart_ID,name,OBJPROP_XDISTANCE,x);
   ObjectSetInteger(chart_ID,name,OBJPROP_YDISTANCE,y);
   return(true);
}

bool LabelCreate(const long              chart_ID=0,               // ID 
                 const string            name="Label",             //  
                 const int               sub_window=0,             //  
                 const int               x=0,                      //    X
                 const int               y=0,                      //    Y
                 const ENUM_BASE_CORNER  corner=CORNER_LEFT_UPPER, //    
                 const string            text="Label",             // 
                 const string            font="Arial",             // 
                 const int               font_size=10,             //  
                 const color             clr=clrRed,               // 
                 const double            angle=0.0,                //  
                 const ENUM_ANCHOR_POINT anchor=ANCHOR_LEFT_UPPER, //  
                 const bool              back=false,               //   
                 const bool              selection=false,          //   
                 const bool              hidden=true,              //    
                 const long              z_order=0)                //    
  {
//---   
   ResetLastError();
//---   
   if(!ObjectCreate(chart_ID,name,OBJ_LABEL,sub_window,0,0))
     {
      Print(__FUNCTION__,
            ":      "+name+"!   = ",GetLastError());
      return(false);
     }
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_XDISTANCE,x);
   ObjectSetInteger(chart_ID,name,OBJPROP_YDISTANCE,y);
//---   ,      
   ObjectSetInteger(chart_ID,name,OBJPROP_CORNER,corner);
//---  
   ObjectSetString(chart_ID,name,OBJPROP_TEXT,text);
//---   
   ObjectSetString(chart_ID,name,OBJPROP_FONT,font);
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_FONTSIZE,font_size);
//---    
   ObjectSetDouble(chart_ID,name,OBJPROP_ANGLE,angle);
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_ANCHOR,anchor);
//---  
   ObjectSetInteger(chart_ID,name,OBJPROP_COLOR,clr);
//---    (false)   (true) 
   ObjectSetInteger(chart_ID,name,OBJPROP_BACK,back);
//---  (true)   (false)    
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTABLE,selection);
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTED,selection);
//---  (true)   (false)      
   ObjectSetInteger(chart_ID,name,OBJPROP_HIDDEN,hidden);
//---         
   ObjectSetInteger(chart_ID,name,OBJPROP_ZORDER,z_order);
//---  
   return(true);
  }

//+------------------------------------------------------------------+
//|  Delete objects function                                         |
//+------------------------------------------------------------------+
int DeleteObjectsByPrefix(string pre)
{
	int obj_total = ObjectsTotal();
	string name;
	
	int count = 0;
	for (int i = obj_total; i >= 0; i--)
	{
		name = ObjectName(i);
		if (StringFind(name, pre) == 0)
		{
			ObjectDelete(name);
			count++;
		}			
	}
	return(count);
}